//+------------------------------------------------------------------+
//|                                                 CCI Ma cross.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Red
#property indicator_color2     MediumSeaGreen
#property indicator_color3     LightSeaGreen
#property indicator_color4     LightSeaGreen
#property indicator_width1     2
#property indicator_width2     1
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern int    CciPeriod        = 50;
extern int    CciPrice         = PRICE_TYPICAL;
extern int    BandPeriod       = 20;
extern int    BandMaType       = MODE_EMA;
extern int    BandPrice        = PRICE_CLOSE;
extern double BandsDeviation   = 2.0; 
extern int    BandsMaMode      = MODE_EMA; 

extern double dnLevel          = -150;
extern double upLevel          = 150;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";

extern string  __              = "arrows settings";
extern bool   ShowArrows       = true; 
extern string ArrowsIdentifier = "cci bands arrow";
extern color  ArrowUpColor     = Aqua;
extern color  ArrowDownColor   = Red; 
extern int    ArrowUpWidth     = 1; 
extern int    ArrowDownWidth   = 1; 

//
//
//
//
//

double cci[];
double cciMa[];
double upMa[];
double dnMa[];
double prices[];
double trend[];
double atrend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,cci);
      SetIndexBuffer(1,cciMa);
      SetIndexBuffer(2,upMa); 
      SetIndexBuffer(3,dnMa); 
      SetIndexBuffer(4,prices);
      SetIndexBuffer(5,trend);
      SetIndexBuffer(6,atrend);
      SetLevelValue(0,upLevel);
      SetLevelValue(1,dnLevel);
      
      
   IndicatorShortName("Cci Bands ("+CciPeriod+","+BandPeriod+")");
return(0);
}

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CciPrice,i);
      double avg = 0; for(k=0; k<CciPeriod; k++) avg +=         prices[i+k];      avg /= CciPeriod;
      double dev = 0; for(k=0; k<CciPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CciPeriod;
         if (dev!=0)
               cci[i] = (prices[i]-avg)/(0.015*dev);
         else  cci[i] = 0;          
   }
   
   for(i=limit; i>=0; i--)
   {
      double StdDev   = iStdDevOnArray(cci,0,BandPeriod,0,BandMaType,i);
      double cciavg   = iMAOnArray(cci,0,BandPeriod,0,BandMaType,i);
             upMa[i]  = cciavg + (StdDev*BandsDeviation);
             dnMa[i]  = cciavg - (StdDev*BandsDeviation);
             cciMa[i] = cciavg;
             trend[i] = trend[i+1];
             if (upMa[i]>upLevel && upMa[i+1]<=upLevel) trend[i] = 1;
             if (dnMa[i]<dnLevel && dnMa[i+1]>=dnLevel) trend[i] =-1;
             manageArrow(i);      
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("crossing upper level");
         else  doAlert("crossing lower level");         
   }
return(0);
}

//
//
//
//
//
 
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Cci bands ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Cci bands "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}


//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      double dist = iATR(NULL,0,20,i)/2.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      atrend[i] = atrend[i+1];
         if (upMa[i]>upLevel && upMa[i+1]<=upLevel) atrend[i] = 1;
         if (dnMa[i]<dnLevel && dnMa[i+1]>=dnLevel) atrend[i] =-1;
         if (atrend[i] !=atrend[i+1])
         {
            string name = ArrowsIdentifier+Time[i];
            if (atrend[i] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,221);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
                  ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth);
            }
            else
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,222);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
                  ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth);
            }
         }
   }
}